<?php
/*
    Description:
        1. This is the webhook endpoint for Stripe to send live events
        2. The webhook endpoint can be configured in Stripe's account dashboard

    References:
        1. https://stripe.com/docs/webhooks
        2. https://stripe.com/docs/webhooks/go-live

    Last Updated: 7-JUL-21
*/

// load WHMCS libraries
require_once __DIR__ . '/../../../init.php';
require_once __DIR__ . '/../../../includes/gatewayfunctions.php';
require_once __DIR__ . '/../../../includes/invoicefunctions.php';

require_once('autoload.php');    // load Stripe FPX classes
require_once('stripe-php-7.69.0/init.php'); // load Stripe PHP library

$callback = new \StripeFPX\Callback();
$callback->process();